// eud2html.js  -- convert eud file to html

main();

function main()
{
    if(WScript.Arguments.length == 0) {
        WScript.Echo("t@Cw肳Ă܂B");
        WScript.Quit(0);
    }

    var i;
    var argc = WScript.Arguments.length;
    for(i = 0; i < argc; i++) {
        conv_file(WScript.Arguments(i));
    }
}

function conv_file(infname)
{
    var ForReading = 1;
    var ForWriting = 2;
    var TristateUseDefault = -2;
    var fso = WScript.CreateObject("Scripting.FileSystemObject");

    var outfname = infname + ".html";

    if(! fso.FileExists(infname)) {
        WScript.Echo("t@C݂܂:", infname);
        return;
    }
    var infile = fso.OpenTextFile(infname, ForReading, false,
                                  TristateUseDefault);
    var data = read_eudfile(infile);
    infile.Close();

    if(fso.FileExists(outfname)) {
        WScript.Echo("t@Cɑ݂܂:", outfname);
        return;
    }
    var outfile = fso.OpenTextFile(outfname, ForWriting, true,
                                   TristateUseDefault);
    write_htmlfile(outfile, data, fso.GetBaseName(infname));
    outfile.Close();
}

function read_eudfile(file)
{
    var line, context = -1, cur;
    var text = "", undo = new Array(), redo = new Array();
    while(! file.AtEndOfStream) {
        line = file.ReadLine();

        if(line == "[TEXT]") {
            context = 0;
        }
        else if(line == "[UNDO]") {
            context = 1;
            cur = null;
        }
        else if(line == "[REDO]") {
            context = 2;
            cur = null;
        }
        else if(context != -1) {
            var r = line.match(/^([^=]*)=(.*)$/);
            if(r) {
                if(context == 0) {
                    if(r[1].match(/^TEXT$/)) {
                        text = r[2];
                    }
                }
                else {
                    if(r[1].match(/^..MODE$/)) {
                        cur = new Array(5);
                        cur[0] = r[2];
                    }
                    else if(r[1].match(/^..CARET_X$/)) {
                        cur[1] = r[2];
                    }
                    else if(r[1].match(/^..CARET_Y$/)) {
                        cur[2] = r[2];
                    }
                    else if(r[1].match(/^..COUNT$/)) {
                        cur[3] = r[2];
                    }
                    else if(r[1].match(/^..TEXT$/)) {
                        cur[4] = r[2];

                        if(context == 1) {
                            undo.push(cur);
                        } else {
                            redo.push(cur);
                        }
                    }
                }
            }
        }
    }

    return new Array(text, undo, redo);
}

function write_htmlfile(file, data, title)
{
    var text = data[0];
    var undo = data[1];
    var redo = data[2];
    var i;

    var header =
        [
            '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"',
            '       "http://www.w3.org/TR/html4/strict.dtd">',
            '<html><head>',
            '<meta http-equiv="content-type" content="text/html; charset=Shift_JIS" />',
            '<title>' + title + '</title>',
            '<style type="text/css">',
            '.oppanel {',
            '  width: 800px;',
            '  background: #f0f0f0;',
            '  padding-top: 0.5em; ',
            '  border: solid 1px #e0e0e0;',
            '}',
            '.buttonbar {',
            '  padding: 0.5em',
            '}',
            '.buttonbar .button {',
            '  width: 3em;',
            '  height: 2em;',
            '  background: #f0f0f0;',
            '  border: solid 3px #e0e0e0;',
            '  margin: 0.2em;',
            '  padding: 0.2em;',
            '  cursor: default;',
            '}',
            '.buttonbar .pressed {',
            '  border: inset 3px #e0e0e0',
            '}',
            '.progressbar {',
            '  height: 1em;',
            '  border: solid 1px #e0e0e0;',
            '  background: #ffffff;',
            '  margin: 0.5em;',
            '}',
            '.progressbar .filler {',
            '  background: #aaaaaa;',
            '  height: 100%;',
            '}',
            '.txtpanel {',
            '  font: 16px "lr oSVbN";',
            '  line-height: 18px;',
            '  white-space: nowrap;',
            '  color: #000000;',
            '  margin: 0.5em;',
            '}',
            '.txtpanel .nl   { color: #80a080; }',
            '.txtpanel .eof  { color: #90b090; }',
            '.txtpanel .hwsp { color: #dddddd; text-decoration: underline; }',
            '.txtpanel .fwsp { color: #f8f8f8; text-decoration: underline; }',
            '',
            '',
            '</style>',
            '</head>',
            '<body>',
            '<div id="eudpanel">',
            '</div>',
            '<script type="text/javascript">'
         ].join("\r\n");

    var footer =
        [
            'document.getElementById("eudpanel").appendChild(',
            '  create_eudplayer(text, undo, redo, 50));',
            '</script>',
            '<noscript>JavaScript Lɂĉ</noscript>',
            '</body>'
         ].join("\r\n");

    var html_procs = [
        create_eudplayer,
        player_rewind, player_ff,
        player_undo, player_redo,
        player_autoundo, player_autoredo,
        player_stop, player_update,
        create_oppanel, oppanel_resetbuttons,
        create_togglebutton, togglebutton_setstate, create_togglebutton_onclick,
        create_steptext,
        create_progressbar, progressbar_setstep,
        create_txtpanel,
        txtpanel_insert_text_nodes, txtpanel_delete_text_nodes,
        txtpanel_change_text_nodes,
        txtpanel_get_caret_pos_index,
        create_newline_node, create_eof_node,
        create_hwsp_node, create_fwsp_node,
        str_colwidth, char_colwidth
        ];

    file.WriteLine(header);

    for(i = 0; i < html_procs.length; i++) {
        file.WriteLine(html_procs[i]);
    }

    file.WriteLine("var text = " + escape_str(text) + ";");
    file.WriteLine("var undo = " + escape_aryary(undo) + ";");
    file.WriteLine("var redo = " + escape_aryary(redo) + ";");
    file.WriteLine(footer);
}

function escape_str(str)
{
    return "\"" +
        str.replace(/[\x00-\x1f\x22\x27\x5c\x7f]/g,
                    function(s) {
                        var v = s.charCodeAt(0).toString(16);
                        return "\\x" + (v.length == 1 ? "0" + v : v); } ) +
        "\"";
}

function escape_ary(ary)
{
    var a = new Array(ary.length);
    var i;

    for(i = 0; i < ary.length; i++) {
        a[i] = escape_str(ary[i]);
    }

    return "[ " + a.join(", ") + " ]";
}

function escape_aryary(ary)
{
    var a = new Array(ary.length);
    var i;

    for(i = 0; i < ary.length; i++) {
        a[i] = escape_ary(ary[i]);
    }

    return "[\r\n" + a.join(",\r\n") + "\r\n]";
}


function create_eudplayer(text, undo, redo, timerms)
{
    var panel = document.createElement("div");
    panel.className = "eudplayer";

    panel.appendChild(create_oppanel());
    panel.appendChild(create_txtpanel());

    panel.childNodes.item(0).childNodes.item(1).totalStep =
        undo.length + redo.length + 1;
    panel.childNodes.item(1).insertTextNodes(0, 0, text);

    panel.rewind = player_rewind;
    panel.fastforward = player_ff;
    panel.undo = player_undo;
    panel.redo = player_redo;
    panel.autoundo = player_autoundo;
    panel.autoredo = player_autoredo;
    panel.stop = player_stop;

    panel.updateStep = player_update;
    panel.undoData = undo;
    panel.redoData = redo;
    panel.timerms = timerms;
    panel.timer = null;
    panel.autoforward = false;

    panel.updateStep();

    return panel;
}

function player_rewind()
{
    this.stop();
    while(this.undoData.length > 0) {
        this.undo();
    }
}

function player_ff()
{
    this.stop();
    while(this.redoData.length > 0) {
        this.redo();
    }
}

function player_undo()
{
    var data = this.undoData.pop();
    if(data) {
        var txtpanel = this.childNodes.item(1);

        if(data[0] == 0) {
            data[4] = txtpanel.deleteTextNodes(data[1], data[2], data[3]);
            data[0] = 1;
        }
        else if(data[0] == 1) {
            txtpanel.insertTextNodes(data[1], data[2], data[4]);
            data[0] = 0;
        }
        else if(data[0] == 2) {
            txtpanel.deleteTextNodes(data[1], data[2], 2);
        }
        else if(data[0] == 3) {
            var n = data[4].split("\x01\x01").length - 1;
            data[4] = txtpanel.changeTextNodes(data[1], data[2],
                                               data[3], data[4], true);
            data[3] = (n < 1 ? 1 : n);
        }

        this.redoData.push(data);
        this.updateStep();
    }
    else {
        this.stop();
    }
}

function player_redo()
{
    var data = this.redoData.pop();
    if(data) {
        var txtpanel = this.childNodes.item(1);

        if(data[0] == 0) {
            data[4] = txtpanel.deleteTextNodes(data[1], data[2], data[3]);
            data[0] = 1;
        }
        else if(data[0] == 1) {
            txtpanel.insertTextNodes(data[1], data[2], data[4]);
            data[0] = 0;
        }
        else if(data[0] == 2) {
            txtpanel.insertTextNodes(data[1], data[2], "\x01\x01");
        }
        else if(data[0] == 3) {
            var n = data[4].split("\x01\x01").length - 1;
            data[4] = txtpanel.changeTextNodes(data[1], data[2],
                                               data[3], data[4], false);
            data[3] = (n < 1 ? 1 : n);
        }

        this.undoData.push(data);
        this.updateStep();
    }
    else {
        this.stop();
    }
}

function player_autoundo()
{
    if(this.timer && (! this.autoforward)) {
        return;
    }
    this.stop();

    var panel = this;
    this.autoforward = false;
    this.timer = window.setInterval(function() { panel.undo(); }, this.timerms);
}

function player_autoredo()
{
    if(this.timer && this.autoforward) {
        return;
    }
    this.stop();

    var panel = this;
    this.autoforward = true;
    this.timer = window.setInterval(function() { panel.redo(); }, this.timerms);
}

function player_stop()
{
    if(this.timer) {
        window.clearInterval(this.timer);
        this.timer = null;

        this.childNodes.item(0).resetButtons();
    }
}

function player_update()
{
    var prgrs = this.childNodes.item(0).childNodes.item(1);
    prgrs.setStep(undo.length);

    var steptext = this.childNodes.item(0).childNodes.item(0).lastChild;
    steptext.replaceChild(
        document.createTextNode("Undo: " + this.undoData.length + " " +
                                "Redo: " + this.redoData.length + " " +
                                "Total: " +
                                (this.undoData.length + this.redoData.length)),
        steptext.childNodes.item(0));
}

function create_oppanel()
{
    var panel = document.createElement("div");
    panel.className = "oppanel";

    var btnbar = document.createElement("div");
    btnbar.className = "buttonbar";

    btnbar.appendChild(create_togglebutton(
                           "|", "擪",
                           function(btn) {
                               panel.parentNode.rewind();
                               panel.resetButtons();
                           }
                           ));
    btnbar.appendChild(create_togglebutton(
                           "|", "Ō",
                           function(btn) {
                               panel.parentNode.fastforward();
                               panel.resetButtons();
                           }
                           ));

    btnbar.appendChild(create_togglebutton(
                           "", "Undo",
                           function(btn) {
                               panel.parentNode.stop();
                               panel.parentNode.undo();
                               panel.resetButtons();
                           }
                           ));
    btnbar.appendChild(create_togglebutton(
                           "", "Redo",
                           function(btn) {
                               panel.parentNode.stop();
                               panel.parentNode.redo();
                               panel.resetButtons();
                           }
                           ));

    btnbar.appendChild(create_togglebutton(
                           "", "AutoUndo",
                           function(btn) {
                               var pressed = btn.buttonPressed;
                               panel.parentNode.stop();
                               panel.resetButtons();
                               if(pressed) {
                                   btn.setToggleState(true);
                                   panel.parentNode.autoundo();
                               }
                           }
                           ));
    btnbar.appendChild(create_togglebutton(
                           "", "AutoRedo",
                           function(btn) {
                               var pressed = btn.buttonPressed;
                               panel.parentNode.stop();
                               panel.resetButtons();
                               if(pressed) {
                                   btn.setToggleState(true);
                                   panel.parentNode.autoredo();
                               }
                           }
                           ));
    btnbar.appendChild(create_steptext());

    panel.appendChild(btnbar);
    panel.appendChild(create_progressbar());

    panel.resetButtons = oppanel_resetbuttons;

    // hide rewind and fastforward buttons, because too slow.
    btnbar.childNodes.item(0).style.display = "none";
    btnbar.childNodes.item(1).style.display = "none";

    return panel;
}

function oppanel_resetbuttons()
{
    var i;
    var btnbar = this.childNodes.item(0);
    for(i = 0; i < btnbar.childNodes.length; i++) {
        if(btnbar.childNodes.item(i).setToggleState) {
            btnbar.childNodes.item(i).setToggleState(false);
        }
    }
}

function create_togglebutton(text, title, onclick)
{
    var btn = document.createElement("input");
    btn.type = "button";
    btn.className = "button";
    btn.value = text;
    btn.title = title;
    btn.buttonPressed = false;
    btn.setToggleState = togglebutton_setstate;
    btn.onclick = create_togglebutton_onclick(onclick);

    return btn;
}

function togglebutton_setstate(ispressed)
{
    this.buttonPressed = ispressed;

    if(ispressed) {
        this.className = "button pressed";
    }
    else {
        this.className = "button";
    }
}

function create_togglebutton_onclick(onclick)
{
    return function() {
        this.setToggleState(! this.buttonPressed);
        onclick(this);
    };
}

function create_steptext()
{
    var node = document.createElement("span");
    node.className = "steptext";
    node.appendChild(document.createTextNode(""));
    return node;
}

function create_progressbar()
{
    var bar = document.createElement("div");
    bar.className = "progressbar";

    var filler = document.createElement("div");
    filler.className = "filler";
    bar.appendChild(filler);

    bar.totalStep = 2;
    bar.setStep = progressbar_setstep;
    bar.setStep(0);

    return bar;
}

function progressbar_setstep(val)
{
    var filler = this.childNodes.item(0);
    filler.style.width = (100 * val / (this.totalStep - 1)) + "%";
}

function create_txtpanel()
{
    var panel = document.createElement("div");
    panel.className = "txtpanel";

    panel.insertTextNodes = txtpanel_insert_text_nodes;
    panel.deleteTextNodes = txtpanel_delete_text_nodes;
    panel.changeTextNodes = txtpanel_change_text_nodes;
    panel.getCaretPosIndex = txtpanel_get_caret_pos_index;

    panel.textData = "";
    panel.appendChild(create_eof_node());

    return panel;
}

function txtpanel_insert_text_nodes(x, y, text)
{
    var index = this.getCaretPosIndex(x, y);
    var refnode = this.childNodes.item(index), newnode;
    var i;

    text = text.replace(/\x01\x01/g, "\n");

    for(i = 0; i < text.length; i++) {
        newnode = null;

        if(text.charCodeAt(i) == 0x0a) {
            newnode = create_newline_node();
        }
        else if(text.charCodeAt(i) == 0x20) {
            newnode = create_hwsp_node();
        }
        else if(text.charCodeAt(i) == 0x3000) {
            newnode = create_fwsp_node();
        }
        else {
            newnode = document.createTextNode(text.charAt(i));
        }

        if(newnode) {
            this.insertBefore(newnode, refnode);
        }
    }

    this.textData =
        this.textData.substr(0, index) + text +
        this.textData.substr(index, this.textData.length - index);
}

function txtpanel_delete_text_nodes(x, y, count)
{
    var index = this.getCaretPosIndex(x, y);
    var node;
    var i, n;

    n = 0;
    for(i = 0; n < count; i++) {
        node = this.childNodes.item(index);
        this.removeChild(node);

        n += char_colwidth(this.textData.charCodeAt(index + i));
    }

    var text = this.textData.substr(index, i);
    this.textData =
        this.textData.substr(0, index) +
        this.textData.substr(index + i, this.textData.length - index - i);

    return text.replace(/\n/g, "\x01\x01");
}

function txtpanel_change_text_nodes(x, y, lines, text, isundo)
{
    var index_from = this.getCaretPosIndex(0, y);
    var index_to;

    y = parseInt(y);
    lines = parseInt(lines);

    if(! text.match(/\x01\x01/)) {
        lines -= 1;
    }
    if(lines == 0) {
        lines = 1;
    }

    if(y + lines < this.textData.split("\n").length) {
        index_to = this.getCaretPosIndex(0, y + lines) - 1;
    }
    else {
        index_to = this.textData.length;
    }
    text = text.replace(/\x01\x01$/, "");

    var res_text = this.deleteTextNodes(
        0, y,
        str_colwidth(this.textData.substr(index_from, index_to - index_from)));
    this.insertTextNodes(0, y, text);

    res_text += "\x01\x01";

    return res_text;
}

function txtpanel_get_caret_pos_index(x, y)
{
    var i, n;

    i = 0;
    for(n = 0; n < y; n++) {
        i = this.textData.indexOf("\n", i) + 1;
        if(i <= 0) {
            i = this.textData.length;
            break;
        }
    }

    n = 0;
    for(; i < this.textData.length; i++) {
        if(n == x) {
            break;
        }

        n += char_colwidth(this.textData.charCodeAt(i));
    }

    return i;
}

function create_eof_node()
{
    var node = document.createElement("span");
    node.className = "eof";
    node.appendChild(document.createTextNode("[EOF]"));
    return node;
}

function create_newline_node()
{
    var node = document.createElement("span");
    node.className = "nl";
    node.appendChild(document.createTextNode(""));
    node.appendChild(document.createElement("br"));
    return node;
}

function create_hwsp_node()
{
    var node = document.createElement("span");
    node.className = "hwsp";
    node.appendChild(document.createTextNode("\u00a0")); // nbsp
    return node;
}

function create_fwsp_node()
{
    var node = document.createElement("span");
    node.className = "fwsp";
    node.appendChild(document.createTextNode("\u3000"));
    return node;
}

function str_colwidth(str)
{
    var i, n = 0;
    for(i = 0; i < str.length; i++) {
        n += char_colwidth(str.charCodeAt(i));
    }
    return n;
}

function char_colwidth(charcode)
{
    if(charcode == 0x0a) {
        return 2;
    }
    else if(charcode <= 0x80 ||
       (0xff61 <= charcode && charcode <= 0xff9f)) {
        return 1;
    }
    else {
        return 2;
    }
}
